$|=1;
@probes=
	(
	"1_Bovine_GV_a_ATCACG",
	"2_Bovine_GV_b1_CGATGT",
	"4_Bovine_MI_1_TGACCA",
	"5_Bovine_MI_2_ACAGTG",
	"6_Bovine_MII_a1_GCCAAT",
	"7_Bovine_MII_a2_CCGTCC",
	"8_Bovine_MII_b1_GTAGAG",
	"9_Bovine_MII_b2_GATCAG",
	"10_Porcine_MII_1_TAGCTT",
	"11_Porcine_MII_2_GGCTAC",
	"12_Porcine_GV_1_CTTGTA",
	"13_Porcine_GV_2_AGTCAA",
	"14_Bovine_ovary_1_AGTTCC",
	"15_Bovine_ovary_2_ATGTCA",
	"16_Bovine_testis_1_CAGATC",
	"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	"20_Porcine_testis_1_GTGGCC",
	"21_Porcine_testis_2_GTTTCG",
	"22_Macaque_ovary_1_CGTACG",
	"23_Macaque_ovary_2_GAGTGG",
	"24_Macaque_testis_1_GGTAGC",
	"25_Macaque_testis_2_TTAGGC",
	"26_Bovine-cumulus-MI-1",
	"27_Bovine-cumulus-MI-2",
	"28_bovine_cumulus_MII_1_TTAGGC",
	"29_bovine_cumulus_MII_2_TGACCA",
	"30_porcine_cumulus_GV_1_ACAGTG",
	"31_porcine_cumulus_GV_2_GCCAAT",
	"32_porcine_GV_1_CAGATC",
	"33_porcine_GV_2_ACTTGA",
	"34_bovine_oxidized_1_GATCAG",
	"35_bovine_oxidized_2_TAGCTT",
	"36_macaque_oxidized_1_GGCTAC",
	"37_macaque_oxidized_2_CTTGTA",
	"38_bovine_IVF_1_AGTCAA",
	"39_bovine_IVF_2_AGTTCC",
	"40_human_ovary_1_ATGTCA",
	"41_human_ovary_2_CCGTCC",
	"42_human_ovary_1_oxidized_GTAGAG",
	"43_human_ovary_2_oxidized_GTCCGC",
	"44_fetal_1st_1_GTGAAA",
	"45_fetal_1st_2_GTGGCC",
	"46_fetal_1st_1_oxidized_GTTTCG",
	"47_fetal_1st_2_oxidized_CGTACG",
	"48_fetal_2nd_1_GAGTGG",
	"49_fetal_2nd_2_GGTAGC",
	"50_fetal_2nd_1_oxidized_ATCACG",
	"51_fetal_2nd_2_oxidized_CGATGT"
	);


###   create temporary ncRNA files for seqmap search   ###
%hsap=
	(
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_lincRNA.fas"=>"lincRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_miRNA.fas"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/miRBase21_hairpin.fa"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_misc_RNA.fas"=>"miscRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_Mt_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_Mt_tRNA.fas"=>"tRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_snoRNA.fas"=>"snoRNA",
	"/media/WD1/Ketting/DBSeq/Hsap_ncRNA_snRNA.fas"=>"snRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_Hsap_Silva119.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_RepBase.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/GtRNAdb_Hsap-hg19_Feb2009.fas"=>"tRNA",
	);

%mmul=
	(
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_lincRNA.fas"=>"lincRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_miRNA.fas"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/miRBase21_hairpin.fa"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_misc_RNA.fas"=>"miscRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_Mt_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_Mt_tRNA.fas"=>"tRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_snoRNA.fas"=>"snoRNA",
	"/media/WD1/Ketting/DBSeq/Mmul_ncRNA_snRNA.fas"=>"snRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_MfasMmul_Silva119.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_RepBase.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/GtRNAdb_Mmul_Jan2006.fas"=>"tRNA"
	);

%btau=
	(
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_miRNA.fas"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/miRBase21_hairpin.fa"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_misc_RNA.fas"=>"miscRNA",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_Mt_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_Mt_tRNA.fas"=>"tRNA",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_snoRNA.fas"=>"snoRNA",
	"/media/WD1/Ketting/DBSeq/Btau_ncRNA_snRNA.fas"=>"snRNA",
	"/media/WD1/Ketting/DBSeq/GtRNAdb_Btau4.0_Oct2007.fas"=>"tRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_RepBase.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_Btau_Silva119.fas"=>"rRNA"
	);

%sscr=
	(
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_lincRNA.fas"=>"lincRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_miRNA.fas"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/miRBase21_hairpin.fa"=>"miRNA_pre",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_misc_RNA.fas"=>"miscRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_Mt_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_Mt_tRNA.fas"=>"tRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_rRNA.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_snoRNA.fas"=>"snoRNA",
	"/media/WD1/Ketting/DBSeq/Sscr_ncRNA_snRNA.fas"=>"snRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_RepBase.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/rRNA_Sscr_Silva119.fas"=>"rRNA",
	"/media/WD1/Ketting/DBSeq/GtRNAdb_Sscrofa9.2_Nov2009.fas"=>"tRNA"
	);

print"\nBuild reference file hsap_ncRNA.temp";
open(TEMP,">hsap_ncRNA.temp");
foreach$file(keys%hsap)
	{
	open(IN,$file)||die print"\nCould not open $file!\n$!\n";
	while(<IN>)
		{
		if($_=~/^>/)
			{
			print TEMP">$hsap{$file}\n";
			}
		else
			{
			$_=~s/U/T/g;
			print TEMP$_;
			}
		}
	close IN;
	}
close TEMP;

print"\nBuild reference file mmul_ncRNA.temp";
open(TEMP,">mmul_ncRNA.temp");
foreach$file(keys%mmul)
	{
	open(IN,$file)||die print"\nCould not open $file!\n$!\n";
	while(<IN>)
		{
		if($_=~/^>/)
			{
			print TEMP">$mmul{$file}\n";
			}
		else
			{
			$_=~s/U/T/g;
			print TEMP$_;
			}
		}
	close IN;
	}
close TEMP;

print"\nBuild reference file btau_ncRNA.temp";
open(TEMP,">btau_ncRNA.temp");
foreach$file(keys%btau)
	{
	open(IN,$file)||die print"\nCould not open $file!\n$!\n";
	while(<IN>)
		{
		if($_=~/^>/)
			{
			print TEMP">$btau{$file}\n";
			}
		else
			{
			$_=~s/U/T/g;
			print TEMP$_;
			}
		}
	close IN;
	}
close TEMP;

print"\nBuild reference file sscr_ncRNA.temp";
open(TEMP,">sscr_ncRNA.temp");
foreach$file(keys%sscr)
	{
	open(IN,$file)||die print"\nCould not open $file!\n$!\n";
	while(<IN>)
		{
		if($_=~/^>/)
			{
			print TEMP">$sscr{$file}\n";
			}
		else
			{
			$_=~s/U/T/g;
			print TEMP$_;
			}
		}
	close IN;
	}
close TEMP;


open(NCRNACOUNTS,">ncRNA_counts.table");
foreach$probe(@probes)
	{
	print"\nMapping $probe\n";
	
	if($probe=~/human/i||$probe=~/fetal/i)
		{
		$ref="hsap_ncRNA.temp";
		}
	elsif($probe=~/macaque/i)
		{
		$ref="mmul_ncRNA.temp";
		}
	elsif($probe=~/bovine/i)
		{
		$ref="btau_ncRNA.temp";
		}
	elsif($probe=~/porcine/i)
		{
		$ref="sscr_ncRNA.temp";
		}
	else
		{
		print"\nDon't know to which file $probe should be mapped!\n";
		exit;
		}
	
	system("./seqmap 0 $probe.clip_nr_ns_18-34_no-miR $ref temp.eland3 /forward_strand /output_all_matches");
	
	print"\nRead map file...";
	%reads=();
	%biotype=();
	%annotation=();
	open(ELAND3,"temp.eland3")||die print"\nCould not open temp.eland3!\n$!\n";
	while(<ELAND3>)
		{
		if($_!~/^trans_id/)
			{
			@d=split("\t",$_);
			$reads{$d[4]}=$d[3];
			if($annotation{$d[4]}!~/$d[0]/)
				{
				$annotation{$d[4]}.="$d[0]\t";
				}
			$biotype{$d[0]}=1;
			}
		}
	close ELAND3;
	
	print" done.\nExport mappers to outfiles...";
	
	%norm_hits_per_biotype=();
	%total_hits_per_biotype=();
	foreach$biotype(keys%biotype)
		{
		open(MAPPERS,">$probe.$biotype");
		foreach$seq(keys%annotation)
			{
			$annotation{$seq}=~s/\t$//;
			@hits=split("\t",$annotation{$seq});
			$n_hits=@hits;
			foreach(@hits)
				{
				if($_ eq $biotype)
					{
					print MAPPERS">$reads{$seq}\n$seq\n";
					$norm_hits_per_biotype{$biotype}+=$reads{$seq}/$n_hits;
					$total_hits_per_biotype{$biotype}+=$reads{$seq};
					last;
					}
				}
			}
		close MAPPERS;
		}
	print" done.\n";
	
	print NCRNACOUNTS"$probe\n";
	print "$probe\n";
	foreach$biotype(keys%norm_hits_per_biotype)
		{
		print NCRNACOUNTS"$biotype\t$norm_hits_per_biotype{$biotype}\t$total_hits_per_biotype{$biotype}\n";
		print "$biotype\t$norm_hits_per_biotype{$biotype}\t$total_hits_per_biotype{$biotype}\n";
		}
	print NCRNACOUNTS"\n";
	print "\n";
	}
close NCRNACOUNTS;