@probes=
	(
	"1_Bovine_GV_a_ATCACG",
	"2_Bovine_GV_b1_CGATGT",
	"4_Bovine_MI_1_TGACCA",
	"5_Bovine_MI_2_ACAGTG",
	"6_Bovine_MII_a1_GCCAAT",
	"7_Bovine_MII_a2_CCGTCC",
	"8_Bovine_MII_b1_GTAGAG",
	"9_Bovine_MII_b2_GATCAG",
	"10_Porcine_MII_1_TAGCTT",
	"11_Porcine_MII_2_GGCTAC",
	"12_Porcine_GV_1_CTTGTA",
	"13_Porcine_GV_2_AGTCAA",
	"14_Bovine_ovary_1_AGTTCC",
	"15_Bovine_ovary_2_ATGTCA",
	"16_Bovine_testis_1_CAGATC",
	"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	"20_Porcine_testis_1_GTGGCC",
	"21_Porcine_testis_2_GTTTCG",
	"22_Macaque_ovary_1_CGTACG",
	"23_Macaque_ovary_2_GAGTGG",
	"24_Macaque_testis_1_GGTAGC",
	"25_Macaque_testis_2_TTAGGC",
	"26_Bovine-cumulus-MI-1",
	"27_Bovine-cumulus-MI-2",
	"28_bovine_cumulus_MII_1_TTAGGC",
	"29_bovine_cumulus_MII_2_TGACCA",
	"30_porcine_cumulus_GV_1_ACAGTG",
	"31_porcine_cumulus_GV_2_GCCAAT",
	"32_porcine_GV_1_CAGATC",
	"33_porcine_GV_2_ACTTGA",
	"34_bovine_oxidized_1_GATCAG",
	"35_bovine_oxidized_2_TAGCTT",
	"36_macaque_oxidized_1_GGCTAC",
	"37_macaque_oxidized_2_CTTGTA",
	"38_bovine_IVF_1_AGTCAA",
	"39_bovine_IVF_2_AGTTCC",
	"40_human_ovary_1_ATGTCA",
	"41_human_ovary_2_CCGTCC",
	"42_human_ovary_1_oxidized_GTAGAG",
	"43_human_ovary_2_oxidized_GTCCGC",
	"44_fetal_1st_1_GTGAAA",
	"45_fetal_1st_2_GTGGCC",
	"46_fetal_1st_1_oxidized_GTTTCG",
	"47_fetal_1st_2_oxidized_CGTACG",
	"48_fetal_2nd_1_GAGTGG",
	"49_fetal_2nd_2_GGTAGC",
	"50_fetal_2nd_1_oxidized_ATCACG",
	"51_fetal_2nd_2_oxidized_CGATGT"
	);
	
$min_size=18;
$max_size=34;

foreach$probe(@probes)
	{
	$in="$probe.clip";
	$out="$probe.clip_$min_size-$max_size";
	
	open(IN,"$in")||die print$!;
	open(OUT,">$out")||die print$!;
	
	while(<IN>)
		{
		$_=~s/\s*$//;
		if($_=~/^>/)
			{
			$title=$_;
			}
		elsif(length$_>=$min_size&&length$_<=$max_size)
			{
			print OUT"$title\n$_\n";
			}
		}
	close IN;
	close OUT;
	}