@samples=
	(
	"1_Bovine_GV_a_ATCACG",
	"2_Bovine_GV_b1_CGATGT",
	"4_Bovine_MI_1_TGACCA",
	"5_Bovine_MI_2_ACAGTG",
	"6_Bovine_MII_a1_GCCAAT",
	"7_Bovine_MII_a2_CCGTCC",
	"8_Bovine_MII_b1_GTAGAG",
	"9_Bovine_MII_b2_GATCAG",
	"10_Porcine_MII_1_TAGCTT",
	"11_Porcine_MII_2_GGCTAC",
	"12_Porcine_GV_1_CTTGTA",
	"13_Porcine_GV_2_AGTCAA",
	"14_Bovine_ovary_1_AGTTCC",
	"15_Bovine_ovary_2_ATGTCA",
	"16_Bovine_testis_1_CAGATC",
	"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	"20_Porcine_testis_1_GTGGCC",
	"21_Porcine_testis_2_GTTTCG",
	"22_Macaque_ovary_1_CGTACG",
	"23_Macaque_ovary_2_GAGTGG",
	"24_Macaque_testis_1_GGTAGC",
	"25_Macaque_testis_2_TTAGGC",
	"26_Bovine-cumulus-MI-1",
	"27_Bovine-cumulus-MI-2",
	"28_bovine_cumulus_MII_1_TTAGGC",
	"29_bovine_cumulus_MII_2_TGACCA",
	"30_porcine_cumulus_GV_1_ACAGTG",
	"31_porcine_cumulus_GV_2_GCCAAT",
	"32_porcine_GV_1_CAGATC",
	"33_porcine_GV_2_ACTTGA",
	"34_bovine_oxidized_1_GATCAG",
	"35_bovine_oxidized_2_TAGCTT",
	"36_macaque_oxidized_1_GGCTAC",
	"37_macaque_oxidized_2_CTTGTA",
	"38_bovine_IVF_1_AGTCAA",
	"39_bovine_IVF_2_AGTTCC",
	"40_human_ovary_1_ATGTCA",
	"41_human_ovary_2_CCGTCC",
	"42_human_ovary_1_oxidized_GTAGAG",
	"43_human_ovary_2_oxidized_GTCCGC",
	"44_fetal_1st_1_GTGAAA",
	"45_fetal_1st_2_GTGGCC",
	"46_fetal_1st_1_oxidized_GTTTCG",
	"47_fetal_1st_2_oxidized_CGTACG",
	"48_fetal_2nd_1_GAGTGG",
	"49_fetal_2nd_2_GGTAGC",
	"50_fetal_2nd_1_oxidized_ATCACG",
	"51_fetal_2nd_2_oxidized_CGATGT"
	);

$|=1;
foreach$file(@samples)
	{
	print"$file\n";
	%length=();
	%base_all=();
	%base=();
	
	open(IN,"$file.passed.mapped.fas")||die print$!;
	open(OUT,">$file.passed.mapped.fas.info")||die print$!;
	while(<IN>)
		{
		chomp$_;
		$_=~s/\s*$//;
		if($_=~s/^>//)
			{
			$reads=$_;
			}
		else
			{
			$length=length$_;
			$length{$length}+=$reads;
			foreach$pos(0..$length-1)
				{
				$base{$length}{$pos+1}{substr($_,$pos,1)}+=$reads;
				$base_all{$pos+1}{substr($_,$pos,1)}+=$reads;
				}
			}
		}
	close IN;
	
	foreach$length(18..34)
		{
		print OUT"$length\t$length{$length}\n";
		}
	
	print OUT"\nPos.\tA\tT\tG\tC\tN\n";
	
	foreach$pos(1..34)
		{
		print OUT"$pos";
		foreach$base('A','T','G','C','N')
			{
			print OUT"\t$base_all{$pos}{$base}"
			}
		print OUT"\n";
		}
	
	print OUT"\nPos.\t18\t\t\t\t\t\t19\t\t\t\t\t\t20\t\t\t\t\t\t21\t\t\t\t\t\t22\t\t\t\t\t\t23\t\t\t\t\t\t24\t\t\t\t\t\t25\t\t\t\t\t\t26\t\t\t\t\t\t27\t\t\t\t\t\t28\t\t\t\t\t\t29\t\t\t\t\t\t30\t\t\t\t\t\t31\t\t\t\t\t\t32\t\t\t\t\t\t33\t\t\t\t\t\t34\n";
	print OUT"\tA\tT\tG\tC\tN\t" x 17;
	print OUT"\n";
	foreach$pos(1..34)
		{
		print OUT"$pos";
		foreach$length(18..34)
			{
			print OUT"\t";
			foreach$base('A','T','G','C','N')
				{
				print OUT"$base{$length}{$pos}{$base}\t";
				}
			}
		print OUT"\n";
		}
	close OUT;
	}